Unit cdp_un;

Interface

Uses
  Classes, Forms, Graphics, DBCtrls, ExtCtrls,
  ComCtrls, MMedia, Buttons,
  Seven, SysUtils, StdCtrls;

Type
  Tcdform = Class (TForm)
    play: TImage;
    stop: TImage;
    pause: TImage;
    volume_change: TTrackBar;
    Volume: TProgressBar;
    CDDevice: TCDDevice;
    Mute: TImage;
    playON: TImage;
    stopOFF: TImage;
    pauseON: TImage;
    NextOFF: TImage;
    DisplayTrack: TSevenSegDisplay;
    PrefOFF: TImage;
    MuteON: TImage;
    Procedure cdformOnActivate (Sender: TObject);
    Procedure MuteONOnClick (Sender: TObject);
    Procedure MuteOnClick (Sender: TObject);
    Procedure EjectOFFOnClick (Sender: TObject);
    Procedure PrefOFFOnClick (Sender: TObject);
    Procedure CDDeviceOnPositionChanged (Sender: TObject;
      Const NewPosition: TTimeInfo);
    Procedure NextOFFOnClick (Sender: TObject);
    Procedure pauseOnClick  ;
    Procedure stopOnClick   ;
    Procedure cdformOnClose ;
    Procedure playOnClick   ;
    Procedure volumeOnChange;
  Private
    {Insert private declarations here}
  Public
    {Insert public declarations here}
  End;

Var
  cdform: Tcdform;
  min,sek,track_save,volume_save : longint;
Implementation

Procedure Tcdform.cdformOnActivate (Sender: TObject);
Begin

End;

Procedure Tcdform.MuteONOnClick (Sender: TObject);
Begin
   CDDevice.Volume[chBoth]:=volume_save;
   Mute.visible:=True;
   MuteON.visible:=False;
End;

Procedure Tcdform.MuteOnClick (Sender: TObject);
Begin
   CDDevice.Volume[chBoth]:=0;
   Mute.visible:=False;
   MuteON.visible:=True;
End;

Procedure Tcdform.EjectOFFOnClick (Sender: TObject);
Begin
  stopOnClick;
  CDDevice.OpenDevice;
End;

Procedure Tcdform.PrefOFFOnClick (Sender: TObject);
Begin
  min:=0; sek:=0;
  CDDevice.PreviousTrack;
End;

Procedure Tcdform.CDDeviceOnPositionChanged (Sender: TObject;
  Const NewPosition: TTimeInfo);
Var
 temp : longint ;
 seks,mins,track: string ;
Begin
  temp:=StrToInt(TimeInfoToString(CDDevice.PositionInTrack));
  sek:=temp/1000-min*60;
  if sek>59 Then
   begin
    min:=min+1;
    sek:=0;
   end;
  if track_save<>CDDevice.CurrentTrack then
     begin
       track_save:=CDDevice.CurrentTrack;
       sek:=0;
       min:=0;
     end;
      seks:=IntToStr(sek);
      mins:=IntToStr(min);
   if sek<10 then seks:='0'+seks;
   if min<10 then mins:='0'+mins;
   track:=IntToStr(CDDevice.CurrentTrack);
   if CDDevice.CurrentTrack<10 then track:='0'+track;
  DisplayTrack.Digits:=track+'-'+mins+':'+seks;
End;

Procedure Tcdform.NextOFFOnClick (Sender: TObject);
Begin
  min:=0; sek:=0;
  CDDevice.NextTrack;
End;

Procedure Tcdform.pauseOnClick (Sender: TObject);
Begin
if playON.visible then
 begin
  if pause.visible Then
   begin
   pause.visible:=False;
   pauseON.visible:=True
   end
  else
   begin
    pauseON.visible:=False;
    pause.visible:=True;
   end;
  CDDevice.Pause;
 end;
End;

Procedure Tcdform.stopOnClick (Sender: TObject);
Begin
  min:=0; sek:=0;
  CDDevice.Stop;
  if pauseON.visible then
     begin
        pauseON.visible:=False;
        pause.visible:=True;
     end;
  playON.visible:=False;
  play.visible:=True;
  stop.visible:=True;
  stopOFF.visible:=False;
  CDDevice.seekToStart;
End;

Procedure Tcdform.cdformOnClose (Sender: TObject; Var Action: TCloseAction);
Begin
  CDDevice.Stop;
End;

Procedure Tcdform.playOnClick;
Begin
  sek:=0; min:=0;
  track_save:=1;
  playON.visible:=True;
  play.visible:=False;
  stop.visible:=False;
  stopOFF.visible:=True;
  CDDevice.Play;
End;

Procedure Tcdform.volumeOnChange;
Begin
    Volume.position:=volume_change.position;
    volume_save:=volume_change.position;
   if Mute.visible then
    CDDevice.Volume[chBoth]:=volume_change.position;
End;

Initialization
  RegisterClasses ([Tcdform, TImage, TTrackBar, TProgressBar, TCDDevice
   , TSevenSegDisplay]);
End.
